package com.tomlost.MSSQL;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;

import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.BA.Permissions;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;

@ShortName("MSSQL")
@Permissions(values={"android.permission.INTERNET","android.permission.ACCESS_NETWORK_STATE"})
@Version((float) 1.01)
@DependsOn(values={"jtds-1.2.5"})
public class MSSQL {
	private String pIPAddress,pDatabaseName,pUserName,pPassword;
	ResultSetMetaData metaData;
	int columnCount = 0, otoID = 1;
	String url, driver;
	ArrayList<String> arrayTablolar = new ArrayList<String>();
	ArrayList<ArrayList<String>> arrayResults = new ArrayList<ArrayList<String>>();
	
	
	public void setDatabase(String IPAddress,String DatabaseName,String UserName,String Password)
	{
		pIPAddress = IPAddress;
		pDatabaseName = DatabaseName;
		pUserName = UserName;
		pPassword = Password;
		url = "jdbc:jtds:sqlserver://" + pIPAddress + ";databaseName="+ pDatabaseName + "";
		driver = "net.sourceforge.jtds.jdbc.Driver";
	}
	
	public ArrayList<ArrayList<String>> Query(String Sql) throws Exception
	{   		
		//try
		//{
		ResultSet rs = QueryExecute(Sql);
		metaData = rs.getMetaData();
		columnCount = metaData.getColumnCount();
		arrayResults.clear();
		addHeaders();
		addRows(rs);
		return arrayResults;
		/*
		}
		catch (Exception e){ 
			if(arrayResults!=null) throw e;
		}
		*/
	}
	private void addHeaders()
	{
		try
		{	
			ArrayList<String> arrayHeader = new ArrayList<String>();
			arrayHeader.clear();
			for (int i=1;i<columnCount+1;i++)
			{
				String cName = metaData.getColumnName(i);
				arrayHeader.add(cName);
			}
			arrayResults.add(arrayHeader);
		}
		catch (SQLException e)
		{
			return;
		}
	}
	
	private void addRows(ResultSet rs)
	{
		try
		{
			int rowCount = 0;
			while(rs.next())
			{
				ArrayList<String> arrayColumns = new ArrayList<String>();
				arrayColumns.clear();
				for (int i=1;i<columnCount+1;i++)
				{					
					String s="";
					if (rs.getString(i)!=null)
						s = rs.getString(i).toString()+"";
						/*
						int t;
						t= metaData.getColumnType(i);
						if(t== java.sql.Types.BIGINT || 
						   t== java.sql.Types.DECIMAL ||
						   t== java.sql.Types.DOUBLE ||
						   t== java.sql.Types.FLOAT ||
						   t== java.sql.Types.INTEGER ||
						   t== java.sql.Types.NUMERIC ||
						   t== java.sql.Types.REAL ||
						   t== java.sql.Types.SMALLINT ||
						   t== java.sql.Types.TINYINT )
							if (s.substring(s.length()-2,2)==".0")
								s = s.substring(0,s.length()-2);
								*/						
					else
						s="Null";
					arrayColumns.add(s);
				}
				arrayResults.add(arrayColumns);
				rowCount++;				
			}
		}
		catch (Exception e)
		{
			return;
		}
	}
	
	private ResultSet QueryExecute(String Sql) throws SQLException,ClassNotFoundException,InstantiationException,IllegalAccessException {
		ResultSet rs = null;
		Connection conn = null;
		Statement stmt = null;
			
		try 
		{
			
			Class.forName(driver).newInstance();
			conn = DriverManager.getConnection(url,pUserName,pPassword);
			stmt = conn.createStatement();
			
			rs = stmt.executeQuery(Sql);
			
		}
		catch (ClassNotFoundException e)	{e.printStackTrace();
											throw new ClassNotFoundException(); 
											}
		catch (SQLException e2)				{e2.printStackTrace(); 											 
											 try {  //An error occured so we rollback the changes. 													 
												   conn.rollback();} 
											       catch (SQLException ex1) { ex1.printStackTrace(); }
											 throw new SQLException(e2);
											}
		catch (InstantiationException e)	{e.printStackTrace();
											throw new InstantiationException();
											}
		catch (IllegalAccessException e)	{e.printStackTrace();
											throw new IllegalAccessException();
											}
		/*
		finally {  
					try {		
		                if (stmt != null) stmt.close();		
		                if (conn != null) conn.close();		
		            	} catch (SQLException ex) { ex.printStackTrace(); }
		        }
		*/
		return rs;
	}

	public void ExecuteNonQuery(String Sql,Boolean Transactional) throws SQLException,ClassNotFoundException,InstantiationException,IllegalAccessException,Exception {
		ResultSet rs = null;
		Connection conn = null;
		Statement stmt = null;
			
		try 
		{
			
			Class.forName(driver).newInstance();
			conn = DriverManager.getConnection(url,pUserName,pPassword);
			conn.setAutoCommit( !Transactional );
			stmt = conn.createStatement();
			
			int i;
  		    i= stmt.executeUpdate(Sql);
			
			if (Transactional==true) conn.commit();
		}
		catch (ClassNotFoundException e)	{e.printStackTrace();
											throw new ClassNotFoundException(); 
											}
		catch (SQLException e2)				{e2.printStackTrace(); 											 
											 try {  //An error occured so we rollback the changes. 													 
												   conn.rollback();} 
											       catch (SQLException ex1) { ex1.printStackTrace(); }
											 throw new SQLException(e2);
											}
		catch (InstantiationException e)	{e.printStackTrace();
											throw new InstantiationException();
											}
		catch (IllegalAccessException e)	{e.printStackTrace();
											throw new IllegalAccessException();
											}
		finally {  try {		
		                if (stmt != null) stmt.close();		
		                if (conn != null) conn.close();		
		            	} catch (SQLException ex) { ex.printStackTrace(); }
		        }
		
	}
	
	public ArrayList<ArrayList<String>> TableList() {
		ArrayList<ArrayList<String>> rs =  new  ArrayList<ArrayList<String>>();
		try {				
			rs = Query("SELECT * FROM INFORMATION_SCHEMA.TABLES");
		} catch (Exception e) {
			//Toast.makeText(this, "ERROR :" + e.toString(), Toast.LENGTH_LONG).show();
			return null;
		}
		return rs;
	}
	 
	/*
	private boolean InternetControl() {
		ConnectivityManager manager = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
		if (manager.getActiveNetworkInfo() != null
				&& manager.getActiveNetworkInfo().isAvailable()
				&& manager.getActiveNetworkInfo().isConnected()) {
			return true;
		} else {
			return false;
		}
	}
	*/
	
	
}
